import type { Nullable } from '@stacksjs/types';

export declare function toArray<T>(array?: Nullable<Arrayable<T>>): Array<T>;
export declare function flatten<T>(array?: Nullable<Arrayable<T | T[]>>): T[];
export declare function mergeArrayable<T>(...args: Nullable<Arrayable<T>>[]): Array<T>;
export declare type PartitionFilter<T> = (i: T, idx: number, arr: readonly T[]) => any
export declare function partition<T>(array: readonly T[], f1: PartitionFilter<T>): [T[], T[]];
export declare function partition<T>(array: readonly T[], f1: PartitionFilter<T>, f2: PartitionFilter<T>): [T[], T[], T[]];
export declare function partition<T>(array: readonly T[], f1: PartitionFilter<T>, f2: PartitionFilter<T>, f3: PartitionFilter<T>): [T[], T[], T[], T[]];
export declare function partition<T>(array: readonly T[], f1: PartitionFilter<T>, f2: PartitionFilter<T>, f3: PartitionFilter<T>, f4: PartitionFilter<T>): [T[], T[], T[], T[], T[]];
export declare function partition<T>(array: readonly T[], f1: PartitionFilter<T>, f2: PartitionFilter<T>, f3: PartitionFilter<T>, f4: PartitionFilter<T>, f5: PartitionFilter<T>): [T[], T[], T[], T[], T[], T[]];
export declare function partition<T>(array: readonly T[], f1: PartitionFilter<T>, f2: PartitionFilter<T>, f3: PartitionFilter<T>, f4: PartitionFilter<T>, f5: PartitionFilter<T>, f6: PartitionFilter<T>): [T[], T[], T[], T[], T[], T[], T[]];
export declare function partition<T>(array: readonly T[], ...filters: PartitionFilter<T>[]): any;
export declare function uniq<T>(array: readonly T[]): T[];
export declare function unique<T>(array: readonly T[]): T[];
export declare function uniqueBy<T>(array: readonly T[], equalFn: (a: any, b: any)): T[];
export declare function last(array: readonly []): undefined;
export declare function last<T>(array: readonly T[]): T;
export declare function last<T>(array: readonly T[]): T | undefined;
export declare function remove<T>(array: T[], value: T): boolean;
export declare function at(array: readonly [], index: number): undefined;
export declare function at<T>(array: readonly T[], index: number): T;
export declare function at<T>(array: readonly T[] | [], index: number): T | undefined;
export declare function move<T>(array: T[], from: number, to: number): T[];
export declare function clampArrayRange(arr: readonly unknown[], n: number): number;
export declare function sample<T>(arr: T[], count: number): T[];
export declare function shuffle<T>(array: T[]): T[];