import type { Nullable } from '@stacksjs/types';
import type { PartitionFilter } from './helpers';

export declare const Arr: {
  contains: (needle: string, haystack: string[]) => void;
  containsAll: (needles: string[], haystack: string[]) => void;
  containsAny: (needles: string[], haystack: string[]) => void;
  containsNone: (needles: string[], haystack: string[]) => void;
  containsOnly: (needles: string[], haystack: string[]) => void;
  doesNotContain: (needle: string, haystack: string[]) => void;
  toArray: <T> (array?: Nullable<Arrayable<T>>) => void;
  flatten: <T> (array?: Nullable<Arrayable<T | T[]>>) => void;
  mergeArrayable: <T> (...args: Nullable<Arrayable<T>>[]) => void;
  partition: <T> (array: readonly T[], filter: PartitionFilter<T>) => void;
  * Returns a random item/s from the array
   */
  random<T>: () => unknown;
  * Returns random item/s from the array
   */
  sample<T>: () => unknown;
  unique: <T> (arr: T[]) => void;
  uniqueBy: <T> (arr: readonly T[], equalFn: (a: any, b: any) => void;
  last: <T> (arr: T[]) => void;
  remove: <T> (arr: T[], value: T) => void;
  at: (arr: any[], index: number) => void;
  range: (arr: readonly number[]) => void;
  move: <T> (arr: T[], from: number, to: number) => void;
  clampArrayRange: (arr: readonly unknown[], n: number) => void;
  shuffle: <T> (arr: T[]) => void;
  * Returns the sum of all items in the array
   */
  sum: () => unknown;
  * Returns the average of all items in the array
   */
  average: () => unknown;
  avg: (arr: number[]) => void;
  * Returns the median of all items in the array
   */
  median: () => unknown;
  * Returns the mode of all items in the array
   */
  mode: () => unknown
};
export declare const arr: typeof Arr;